#ifndef MATHLIB_UTILITY_H
#define MATHLIB_UTILITY_H

// random mathematics functions

#include <cmath>

#include <mathlib/mathdefs.h>

namespace mathlib {

inline float sqr(float a) { return a*a; }

inline bool close(float a, float b) {
	return std::abs(a - b) < epsilon;
}

inline int sign(float a) {
	if (a > epsilon) return 1;
	if (a < -epsilon) return -1;
	return 0;
}

} // namespace mathlib

#endif
